# PyFWI
[![PyPI version](https://badge.fury.io/py/PyFWI.svg)](https://badge.fury.io/py/PyFWI)
[![License: GPL v3](https://img.shields.io/badge/License-GPLv3-blue.svg)](https://www.gnu.org/licenses/gpl-3.0)
[![Documentation Status](https://readthedocs.org/projects/pyfwi/badge/?version=latest)](https://pyfwi.readthedocs.io/en/latest/?badge=latest)
[![DOI](https://zenodo.org/badge/402170735.svg)](https://zenodo.org/badge/latestdoi/402170735)
[![Downloads](https://static.pepy.tech/personalized-badge/pyfwi?period=total&units=none&left_color=grey&right_color=green&left_text=Downloads)](https://pepy.tech/project/pyfwi)
<img src="https://visitor-badge.laobi.icu/badge?page_id=pyfwi_unique12.pyfwi_unique12"/>

This repository contains Python package for elastic seismic full-waveform inversion (FWI) and time-lapse FWI.
Documentation of PyFWI is available [here](https://pyfwi.readthedocs.io/en/latest/index.html).


## Installation
To install this package, run 
```
python3 -m pip install PyFWI
```
on macOS or 
```
py -m pip install PyFWI
```
on Windows.

The structure of PyFWI can be shown as

![PyFWI_structure](docs/pyfwi_structure.png)

## Citing PyFWI
```
@article{mardan2023pyfwi,
  title = {PyFWI: {A Python} package for full-waveform inversion and reservoir monitoring},
  author = {Mardan, Amir and Giroux, Bernard and Fabien-Ouellet, Gabriel},
  journal = {SoftwareX},
  volume = {22},
  pages = {101384},
  year = {2023},
  publisher = {Elsevier},
  doi = {10.1016/j.softx.2023.101384}
}
```
